Index: trunk/source/processes/hadronic/models/pre_equilibrium/exciton_model/src/G4PreCompoundNucleon.cc
===================================================================
--- trunk/source/processes/hadronic/models/pre_equilibrium/exciton_model/src/G4PreCompoundNucleon.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/pre_equilibrium/exciton_model/src/G4PreCompoundNucleon.cc	(revision 1055)
@@ -24,6 +24,19 @@
 // ********************************************************************
 //
-//J. M. Quesada (August 2008).  
-//Based  on previous work by V. Lara
+//
+// $Id: G4PreCompoundNucleon.cc,v 1.13 2009/02/11 18:06:00 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+//
+// -------------------------------------------------------------------
+//
+// GEANT4 Class file
+//
+//
+// File name:     G4PreCompoundNucleon
+//
+// Author:         V.Lara
+//
+// Modified:  
+// 10.02.2009 J. M. Quesada cleanup
 //
 
@@ -32,10 +45,9 @@
 
 G4bool G4PreCompoundNucleon::IsItPossible(const G4Fragment& aFragment) 
-  {
-    G4int pplus = aFragment.GetNumberOfCharged();   
-    G4int pneut = aFragment.GetNumberOfParticles()-pplus;
-    return (pneut >= (GetA()-GetZ()) && pplus >= GetZ());
-  }
-
+{
+  G4int pplus = aFragment.GetNumberOfCharged();   
+  G4int pneut = aFragment.GetNumberOfParticles()-pplus;
+  return (pneut >= (GetA()-GetZ()) && pplus >= GetZ());
+}
 
 G4double G4PreCompoundNucleon::
@@ -45,5 +57,4 @@
   if ( !IsItPossible(aFragment) ) return 0.0;
 
-
   G4double U = aFragment.GetExcitationEnergy();
   G4double P = aFragment.GetNumberOfParticles();
@@ -51,6 +62,4 @@
   G4double N = P + H;
   
-
-
   G4double g0 = (6.0/pi2)*aFragment.GetA() * 
     G4PreCompoundParameters::GetAddress()->GetLevelDensity();
@@ -58,6 +67,4 @@
   G4double g1 = (6.0/pi2)*GetRestA() * 
     G4PreCompoundParameters::GetAddress()->GetLevelDensity();
-
-
 
   G4double A0 = ((P*P+H*H+P-H)/4.0 - H/2.0)/g0;
@@ -71,16 +78,18 @@
 
 
- G4double Probability =1.e-25* 1.0/pi2*2.0/(hbarc*hbarc*hbarc) * GetReducedMass()
-* GetRj(aFragment.GetNumberOfParticles(), aFragment.GetNumberOfCharged())  * eKin*CrossSection(eKin) * P*(N-1.0) * std::pow(g1*E1/(g0*E0),N-2.0)/E0 * g1/(g0*g0);
+  G4double Probability = 1.0/pi2*2.0/(hbarc*hbarc*hbarc) * GetReducedMass()
+    * GetRj(aFragment.GetNumberOfParticles(), aFragment.GetNumberOfCharged())  
+    * eKin*CrossSection(eKin)*millibarn * P*(N-1.0) * std::pow(g1*E1/(g0*E0),N-2.0)/E0 * g1/(g0*g0);
 
-
-if (GetRj(aFragment.GetNumberOfParticles(), aFragment.GetNumberOfCharged())<0.0 || CrossSection(eKin) <0)
-{  std::ostringstream errOs;
-   G4cout<<"WARNING:  NEGATIVE VALUES "<<G4endl;     
-        errOs << "Rj=" << GetRj(aFragment.GetNumberOfParticles(), aFragment.GetNumberOfCharged())<<G4endl;
-        errOs <<"  xsec("<<eKin<<" MeV) ="<<CrossSection(eKin)<<G4endl;
-        errOs <<"  A="<<GetA()<<"  Z="<<GetZ()<<G4endl;
-        throw G4HadronicException(__FILE__, __LINE__, errOs.str());
-              }
+  if (GetRj(aFragment.GetNumberOfParticles(), aFragment.GetNumberOfCharged())<0.0 
+      || CrossSection(eKin) <0) {  
+    std::ostringstream errOs;
+    G4cout<<"WARNING:  NEGATIVE VALUES "<<G4endl;     
+    errOs << "Rj=" << GetRj(aFragment.GetNumberOfParticles(), aFragment.GetNumberOfCharged())
+	  <<G4endl;
+    errOs <<"  xsec("<<eKin<<" MeV) ="<<CrossSection(eKin)<<G4endl;
+    errOs <<"  A="<<GetA()<<"  Z="<<GetZ()<<G4endl;
+    throw G4HadronicException(__FILE__, __LINE__, errOs.str());
+  }
 
   return Probability;
Index: trunk/source/processes/hadronic/models/pre_equilibrium/exciton_model/src/G4PreCompoundProton.cc
===================================================================
--- trunk/source/processes/hadronic/models/pre_equilibrium/exciton_model/src/G4PreCompoundProton.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/pre_equilibrium/exciton_model/src/G4PreCompoundProton.cc	(revision 1055)
@@ -24,35 +24,43 @@
 // ********************************************************************
 //
-//J.M.Quesada (August 08). New source file
-// 
-// Modif (21 August 2008) by J. M. Quesada for external choice of inverse 
-// cross section option
-// 
-// JMQ (06 September 2008) Also external choice has been added for:
-//                      - superimposed Coulomb barrier (if useSICB=true) 
+//
+// $Id: G4PreCompoundProton.cc,v 1.4 2009/02/11 18:06:00 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+//
+// -------------------------------------------------------------------
+//
+// GEANT4 Class file
+//
+//
+// File name:     G4PreCompoundProton
+//
+// Author:         V.Lara
+//
+// Modified:  
+// 21.08.2008 J. M. Quesada added external choice of inverse cross section option
+// 21.08.2008 J. M. Quesada added external choice for superimposed Coulomb barrier 
+//                          (if useSICB=true) 
+//
 
 #include "G4PreCompoundProton.hh"
 
-  G4ReactionProduct * G4PreCompoundProton::GetReactionProduct() const
-  {
-    G4ReactionProduct * theReactionProduct = 
-      new G4ReactionProduct(G4Proton::ProtonDefinition());
-    theReactionProduct->SetMomentum(GetMomentum().vect());
-    theReactionProduct->SetTotalEnergy(GetMomentum().e());
+G4ReactionProduct * G4PreCompoundProton::GetReactionProduct() const
+{
+  G4ReactionProduct * theReactionProduct = 
+    new G4ReactionProduct(G4Proton::ProtonDefinition());
+  theReactionProduct->SetMomentum(GetMomentum().vect());
+  theReactionProduct->SetTotalEnergy(GetMomentum().e());
 #ifdef PRECOMPOUND_TEST
-    theReactionProduct->SetCreatorModel("G4PrecompoundModel");
+  theReactionProduct->SetCreatorModel("G4PrecompoundModel");
 #endif
-    return theReactionProduct;
-  }
-
-
-   G4double G4PreCompoundProton::GetRj(const G4int NumberParticles, const G4int NumberCharged)
-  {
-    G4double rj = 0.0;
-    if(NumberParticles > 0) rj = static_cast<G4double>(NumberCharged)/static_cast<G4double>(NumberParticles);
-    return rj;
-  }
-
-
+  return theReactionProduct;
+}
+
+G4double G4PreCompoundProton::GetRj(const G4int NumberParticles, const G4int NumberCharged)
+{
+  G4double rj = 0.0;
+  if(NumberParticles > 0) rj = static_cast<G4double>(NumberCharged)/static_cast<G4double>(NumberParticles);
+  return rj;
+}
 
 ////////////////////////////////////////////////////////////////////////////////////
@@ -63,5 +71,5 @@
 //OPT=3 Kalbach's parameterization 
 // 
- G4double G4PreCompoundProton::CrossSection(const  G4double K)
+G4double G4PreCompoundProton::CrossSection(const  G4double K)
 {
   //G4cout<<" In G4PreCompoundProton OPTxs="<<OPTxs<<G4endl;
@@ -75,6 +83,4 @@
   FragmentA=GetA()+GetRestA();
   FragmentAthrd=std::pow(FragmentA,0.33333);
-
-
 
   if (OPTxs==0) return GetOpt0(K);
@@ -94,37 +100,35 @@
 G4double G4PreCompoundProton::GetOpt0(const  G4double K)
 {
-const G4double r0 = G4PreCompoundParameters::GetAddress()->Getr0();
+  const G4double r0 = G4PreCompoundParameters::GetAddress()->Getr0();
   // cross section is now given in mb (r0 is in mm) for the sake of consistency
   //with the rest of the options
- return 1.e+25*pi*(r0*ResidualAthrd)*(r0*ResidualAthrd)*GetAlpha()*(1.+GetBeta()/K);
+  return 1.e+25*pi*(r0*ResidualAthrd)*(r0*ResidualAthrd)*GetAlpha()*(1.+GetBeta()/K);
 }
 //
 //------------
 //
-  G4double G4PreCompoundProton::GetAlpha()
-  {
- G4double aZ = static_cast<G4double>(GetRestZ());
-    G4double C = 0.0;
-    if (aZ >= 70) 
-      {
-	C = 0.10;
-      } 
-    else 
-      {
-	C = ((((0.15417e-06*aZ) - 0.29875e-04)*aZ + 0.21071e-02)*aZ - 0.66612e-01)*aZ + 0.98375;
-      }
-    return 1.0 + C;
-  }
+G4double G4PreCompoundProton::GetAlpha()
+{
+  G4double aZ = static_cast<G4double>(GetRestZ());
+  G4double C = 0.0;
+  if (aZ >= 70) 
+    {
+      C = 0.10;
+    } 
+  else 
+    {
+      C = ((((0.15417e-06*aZ) - 0.29875e-04)*aZ + 0.21071e-02)*aZ - 0.66612e-01)*aZ + 0.98375;
+    }
+  return 1.0 + C;
+}
 //
 //-------------------
 //  
-  G4double G4PreCompoundProton::GetBeta() 
-  {
+G4double G4PreCompoundProton::GetBeta() 
+{
   return -GetCoulombBarrier();
-  }
-//
-  
-
-
+}
+//
+  
 //********************* OPT=1 : Chatterjee's cross section ************************ 
 //(fitting to cross section from Bechetti & Greenles OM potential)
@@ -132,42 +136,40 @@
 G4double G4PreCompoundProton::GetOpt1(const  G4double K)
 {
- G4double Kc=K; 
-
-// JMQ  xsec is set constat above limit of validity
- if (K>50)  Kc=50;
-
- G4double landa, landa0, landa1, mu, mu0, mu1,nu, nu0, nu1, nu2,xs;
- G4double p, p0, p1, p2,Ec,delta,q,r,ji;
-  
- p0 = 15.72;
- p1 = 9.65;
- p2 = -449.0;
- landa0 = 0.00437;
- landa1 = -16.58;
- mu0 = 244.7;
- mu1 = 0.503;
- nu0 = 273.1;
- nu1 = -182.4;
- nu2 = -1.872;  
- delta=0.;  
-
- Ec = 1.44*theZ*ResidualZ/(1.5*ResidualAthrd+delta);
- p = p0 + p1/Ec + p2/(Ec*Ec);
- landa = landa0*ResidualA + landa1;
- mu = mu0*std::pow(ResidualA,mu1);
- nu = std::pow(ResidualA,mu1)*(nu0 + nu1*Ec + nu2*(Ec*Ec));
- q = landa - nu/(Ec*Ec) - 2*p*Ec;
- r = mu + 2*nu/Ec + p*(Ec*Ec);
-
- ji=std::max(Kc,Ec);
- if(Kc < Ec) { xs = p*Kc*Kc + q*Kc + r;}
- else {xs = p*(Kc - ji)*(Kc - ji) + landa*Kc + mu + nu*(2 - Kc/ji)/ji ;}
- if (xs <0.0) {xs=0.0;}
-
- return xs; 
-
-}
-
-
+  G4double Kc=K; 
+
+  // JMQ  xsec is set constat above limit of validity
+  if (K>50)  Kc=50;
+
+  G4double landa, landa0, landa1, mu, mu0, mu1,nu, nu0, nu1, nu2,xs;
+  G4double p, p0, p1, p2,Ec,delta,q,r,ji;
+  
+  p0 = 15.72;
+  p1 = 9.65;
+  p2 = -449.0;
+  landa0 = 0.00437;
+  landa1 = -16.58;
+  mu0 = 244.7;
+  mu1 = 0.503;
+  nu0 = 273.1;
+  nu1 = -182.4;
+  nu2 = -1.872;  
+  delta=0.;  
+
+  Ec = 1.44*theZ*ResidualZ/(1.5*ResidualAthrd+delta);
+  p = p0 + p1/Ec + p2/(Ec*Ec);
+  landa = landa0*ResidualA + landa1;
+  mu = mu0*std::pow(ResidualA,mu1);
+  nu = std::pow(ResidualA,mu1)*(nu0 + nu1*Ec + nu2*(Ec*Ec));
+  q = landa - nu/(Ec*Ec) - 2*p*Ec;
+  r = mu + 2*nu/Ec + p*(Ec*Ec);
+
+  ji=std::max(Kc,Ec);
+  if(Kc < Ec) { xs = p*Kc*Kc + q*Kc + r;}
+  else {xs = p*(Kc - ji)*(Kc - ji) + landa*Kc + mu + nu*(2 - Kc/ji)/ji ;}
+  if (xs <0.0) {xs=0.0;}
+
+  return xs; 
+
+}
 
 //************* OPT=2 : Welisch's proton reaction cross section ************************ 
@@ -178,6 +180,6 @@
   G4double rnpro,rnneu,eekin,ekin,ff1,ff2,ff3,r0,fac,fac1,fac2,b0,xine_th(0);
  
-//This is redundant when the Coulomb  barrier is overimposed to all cross sections 
-//It should be kept when Coulomb barrier only imposed at OPTxs=2
+  //This is redundant when the Coulomb  barrier is overimposed to all cross sections 
+  //It should be kept when Coulomb barrier only imposed at OPTxs=2
 
   if(!useSICB && K<=theCoulombBarrier) return xine_th=0.0;
@@ -316,7 +318,6 @@
   }   //end for E>Ec
 
-  return sig;}
-
-
+  return sig;
+}
 
 //   ************************** end of cross sections ******************************* 
Index: trunk/source/processes/hadronic/models/pre_equilibrium/exciton_model/src/G4PreCompoundTransitions.cc
===================================================================
--- trunk/source/processes/hadronic/models/pre_equilibrium/exciton_model/src/G4PreCompoundTransitions.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/pre_equilibrium/exciton_model/src/G4PreCompoundTransitions.cc	(revision 1055)
@@ -24,10 +24,22 @@
 // ********************************************************************
 //
-//
-//J. M. Quesada (Feb. 08). Base on previous work by V. Lara.
-// New transition probabilities. Several bugs fixed.
-// JMQ (06 September 2008) Also external choices have been added for:
+// $Id: G4PreCompoundTransitions.cc,v 1.20 2009/02/10 16:01:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+//
+// -------------------------------------------------------------------
+//
+// GEANT4 Class file
+//
+//
+// File name:     G4PreCompoundIon
+//
+// Author:         V.Lara
+//
+// Modified:  
+// 16.02.2008 J. M. Quesada fixed bugs 
+// 06.09.2008 J. M. Quesada added external choices for:
 //                      - "never go back"  hipothesis (useNGB=true) 
 //                      -  CEM transition probabilities (useCEMtr=true)
+
 #include "G4PreCompoundTransitions.hh"
 #include "G4HadronicException.hh"
@@ -184,5 +196,6 @@
     //  G4cout<<"N="<<N<<"  P="<<P<<"  H="<<H<<G4endl;
     //  G4cout<<"l+ ="<<TransitionProb1<<"  l- ="<< TransitionProb2<<"  l0 ="<< TransitionProb3<<G4endl; 
-    return TransitionProb1 + TransitionProb2 + TransitionProb3;}
+    return TransitionProb1 + TransitionProb2 + TransitionProb3;
+  }
   
   else  {
@@ -215,6 +228,4 @@
     return TransitionProb1 + TransitionProb2 + TransitionProb3;
   }
-
-
 }
 
@@ -237,17 +248,21 @@
     }
 
-  // AH/JMQ: Randomly decrease the number of charges if deltaN is -2 and in proportion to the number charges w.r.t. number of particles,  PROVIDED that there are charged particles
-  if(deltaN < 0 && G4UniformRand() <= static_cast<G4double>(result.GetNumberOfCharged())/static_cast<G4double>(result.GetNumberOfParticles()) && (result.GetNumberOfCharged() >= 1))
+  // AH/JMQ: Randomly decrease the number of charges if deltaN is -2 and in proportion 
+  // to the number charges w.r.t. number of particles,  PROVIDED that there are charged particles
+  if(deltaN < 0 && G4UniformRand() <= 
+     static_cast<G4double>(result.GetNumberOfCharged())/static_cast<G4double>(result.GetNumberOfParticles()) 
+     && (result.GetNumberOfCharged() >= 1)) {
     result.SetNumberOfCharged(result.GetNumberOfCharged()+deltaN/2); // deltaN is negative!
-
-
- //JMQ the following lines have to be before SetNumberOfCharged, otherwise the check on number of charged vs. number of particles fails
+  }
+
+  // JMQ the following lines have to be before SetNumberOfCharged, otherwise the check on 
+  // number of charged vs. number of particles fails
   result.SetNumberOfParticles(result.GetNumberOfParticles()+deltaN/2);
   result.SetNumberOfHoles(result.GetNumberOfHoles()+deltaN/2); 
 
- // With weight Z/A, number of charged particles is increased with +1
+  // With weight Z/A, number of charged particles is increased with +1
   if ( ( deltaN > 0 ) &&
       (G4UniformRand() <= static_cast<G4double>(result.GetZ()-result.GetNumberOfCharged())/
-		  std::max(static_cast<G4double>(result.GetA()-Nexcitons),1.)))
+       std::max(static_cast<G4double>(result.GetA()-Nexcitons),1.)))
     {
       result.SetNumberOfCharged(result.GetNumberOfCharged()+deltaN/2);
Index: trunk/source/processes/hadronic/models/pre_equilibrium/exciton_model/src/G4PreCompoundTriton.cc
===================================================================
--- trunk/source/processes/hadronic/models/pre_equilibrium/exciton_model/src/G4PreCompoundTriton.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/pre_equilibrium/exciton_model/src/G4PreCompoundTriton.cc	(revision 1055)
@@ -25,27 +25,39 @@
 //
 //
-//J.M.Quesada (August 08). New source file
-//
-// Modif (21 August 2008) by J. M. Quesada for external choice of inverse 
-// cross section option
+// $Id: G4PreCompoundTriton.cc,v 1.5 2009/02/13 18:57:32 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+//
+// -------------------------------------------------------------------
+//
+// GEANT4 Class file
+//
+//
+// File name:     G4PreCompoundTriton
+//
+// Author:         V.Lara
+//
+// Modified:  
+// 21.08.2008 J. M. Quesada add choice of options  
+// 10.02.2009 J. M. Quesada set default opt1  
+//
  
 #include "G4PreCompoundTriton.hh"
 
 
-  G4ReactionProduct * G4PreCompoundTriton::GetReactionProduct() const
-  {
-    G4ReactionProduct * theReactionProduct =
-      new G4ReactionProduct(G4Triton::TritonDefinition());
-    theReactionProduct->SetMomentum(GetMomentum().vect());
-    theReactionProduct->SetTotalEnergy(GetMomentum().e());
+G4ReactionProduct * G4PreCompoundTriton::GetReactionProduct() const
+{
+  G4ReactionProduct * theReactionProduct =
+    new G4ReactionProduct(G4Triton::TritonDefinition());
+  theReactionProduct->SetMomentum(GetMomentum().vect());
+  theReactionProduct->SetTotalEnergy(GetMomentum().e());
 #ifdef PRECOMPOUND_TEST
-    theReactionProduct->SetCreatorModel("G4PrecompoundModel");
+  theReactionProduct->SetCreatorModel("G4PrecompoundModel");
 #endif
-    return theReactionProduct;
-  }   
-
-   G4double G4PreCompoundTriton::FactorialFactor(const G4double N, const G4double P)
-  {
-      return 
+  return theReactionProduct;
+}   
+
+G4double G4PreCompoundTriton::FactorialFactor(const G4double N, const G4double P)
+{
+  return 
       (N-3.0)*(P-2.0)*(
 		       (((N-2.0)*(P-1.0))/2.0) *(
@@ -53,22 +65,21 @@
 						 )
 		       );
+}
+  
+G4double G4PreCompoundTriton::CoalescenceFactor(const G4double A)
+{
+  return 243.0/(A*A);
+}    
+
+G4double G4PreCompoundTriton::GetRj(const G4int NumberParticles, const G4int NumberCharged)
+{
+  G4double rj = 0.0;
+  G4double denominator = NumberParticles*(NumberParticles-1)*(NumberParticles-2);
+  if(NumberCharged >= 1 && (NumberParticles-NumberCharged) >= 2) {
+    rj = 3.0*static_cast<G4double>(NumberCharged*(NumberParticles-NumberCharged)*(NumberParticles-NumberCharged-1))
+      /static_cast<G4double>(denominator); 
   }
-  
-   G4double G4PreCompoundTriton::CoalescenceFactor(const G4double A)
-  {
-     return 243.0/(A*A);
-  }    
-
-
-   G4double G4PreCompoundTriton::GetRj(const G4int NumberParticles, const G4int NumberCharged)
-  {
-    G4double rj = 0.0;
-    G4double denominator = NumberParticles*(NumberParticles-1)*(NumberParticles-2);
-    if(NumberCharged >= 1 && (NumberParticles-NumberCharged) >= 2) rj = 3.0*static_cast<G4double>(NumberCharged*(NumberParticles-NumberCharged)*(NumberParticles-NumberCharged-1))/static_cast<G4double>(denominator); 
-    return rj;
-  }
-
-
-
+  return rj;
+}
 
 ////////////////////////////////////////////////////////////////////////////////////
@@ -78,5 +89,5 @@
 //OPT=3,4 Kalbach's parameterization 
 // 
- G4double G4PreCompoundTriton::CrossSection(const  G4double K)
+G4double G4PreCompoundTriton::CrossSection(const  G4double K)
 {
   ResidualA=GetRestA();
@@ -111,26 +122,26 @@
 //---------
 //
-  G4double G4PreCompoundTriton::GetAlpha()
-  {
-    G4double C = 0.0;
-    G4double aZ = GetZ() + GetRestZ();
-    if (aZ >= 70) 
-      {
-	C = 0.10;
-      } 
-    else 
-      {
-	C = ((((0.15417e-06*aZ) - 0.29875e-04)*aZ + 0.21071e-02)*aZ - 0.66612e-01)*aZ + 0.98375; 
-      }
- 
-    return 1.0 + C/3.0;
-  }
+G4double G4PreCompoundTriton::GetAlpha()
+{
+  G4double C = 0.0;
+  G4double aZ = GetZ() + GetRestZ();
+  if (aZ >= 70) 
+    {
+      C = 0.10;
+    } 
+  else 
+    {
+      C = ((((0.15417e-06*aZ) - 0.29875e-04)*aZ + 0.21071e-02)*aZ - 0.66612e-01)*aZ + 0.98375; 
+    }
+ 
+  return 1.0 + C/3.0;
+}
 //
 //-------------
 //
-   G4double G4PreCompoundTriton::GetBeta() 
-  {
-      return -GetCoulombBarrier();
-  }
+G4double G4PreCompoundTriton::GetBeta() 
+{
+  return -GetCoulombBarrier();
+}
 //
 //********************* OPT=1,2 : Chatterjee's cross section ************************ 
@@ -183,66 +194,64 @@
 
   G4double landa, mu, nu, p , signor(1.),sig;
-G4double ec,ecsq,xnulam,etest(0.),a; 
-G4double b,ecut,cut,ecut2,geom,elab;
-
-
- G4double     flow = 1.e-18;
- G4double     spill= 1.e+18;
-
-
- G4double     p0 = -21.45;
- G4double     p1 = 484.7;
- G4double     p2 = -1608.;
- G4double     landa0 = 0.0186;
- G4double     landa1 = -8.90;
- G4double     mu0 = 686.3;
- G4double     mu1 = 0.325;
- G4double     nu0 = 368.9;
- G4double     nu1 = -522.2;
- G4double     nu2 = -4.998;  
+  G4double ec,ecsq,xnulam,etest(0.),a; 
+  G4double b,ecut,cut,ecut2,geom,elab;
+
+
+  G4double     flow = 1.e-18;
+  G4double     spill= 1.e+18;
+
+
+  G4double     p0 = -21.45;
+  G4double     p1 = 484.7;
+  G4double     p2 = -1608.;
+  G4double     landa0 = 0.0186;
+  G4double     landa1 = -8.90;
+  G4double     mu0 = 686.3;
+  G4double     mu1 = 0.325;
+  G4double     nu0 = 368.9;
+  G4double     nu1 = -522.2;
+  G4double     nu2 = -4.998;  
   
- G4double      ra=0.80;
+  G4double      ra=0.80;
         
- ec = 1.44 * theZ * ResidualZ / (1.5*ResidualAthrd+ra);
- ecsq = ec * ec;
- p = p0 + p1/ec + p2/ecsq;
- landa = landa0*ResidualA + landa1;
- a = std::pow(ResidualA,mu1);
- mu = mu0 * a;
- nu = a* (nu0+nu1*ec+nu2*ecsq);  
- xnulam = nu / landa;
- if (xnulam > spill) xnulam=0.;
- if (xnulam >= flow) etest = 1.2 *std::sqrt(xnulam);
- 
- a = -2.*p*ec + landa - nu/ecsq;
- b = p*ecsq + mu + 2.*nu/ec;
- ecut = 0.;
- cut = a*a - 4.*p*b;
- if (cut > 0.) ecut = std::sqrt(cut);
- ecut = (ecut-a) / (p+p);
- ecut2 = ecut;
- if (cut < 0.) ecut2 = ecut - 2.;
- elab = K * FragmentA / ResidualA;
- sig = 0.;
- 
- if (elab <= ec) { //start for E<Ec
-   if (elab > ecut2)  sig = (p*elab*elab+a*elab+b) * signor;    
- }           //end for E<Ec
- else {           //start for E>Ec
-   sig = (landa*elab+mu+nu/elab) * signor;
-   geom = 0.;
-   if (xnulam < flow || elab < etest) return sig;
-   geom = std::sqrt(theA*K);
-   geom = 1.23*ResidualAthrd + ra + 4.573/geom;
-   geom = 31.416 * geom * geom;
-   sig = std::max(geom,sig);
- }           //end for E>Ec
- return sig;
+  //JMQ 13/02/09 increase of reduced radius to lower the barrier
+  // ec = 1.44 * theZ * ResidualZ / (1.5*ResidualAthrd+ra);
+  ec = 1.44 * theZ * ResidualZ / (1.7*ResidualAthrd+ra);
+  ecsq = ec * ec;
+  p = p0 + p1/ec + p2/ecsq;
+  landa = landa0*ResidualA + landa1;
+  a = std::pow(ResidualA,mu1);
+  mu = mu0 * a;
+  nu = a* (nu0+nu1*ec+nu2*ecsq);  
+  xnulam = nu / landa;
+  if (xnulam > spill) xnulam=0.;
+  if (xnulam >= flow) etest = 1.2 *std::sqrt(xnulam);
+ 
+  a = -2.*p*ec + landa - nu/ecsq;
+  b = p*ecsq + mu + 2.*nu/ec;
+  ecut = 0.;
+  cut = a*a - 4.*p*b;
+  if (cut > 0.) ecut = std::sqrt(cut);
+  ecut = (ecut-a) / (p+p);
+  ecut2 = ecut;
+  if (cut < 0.) ecut2 = ecut - 2.;
+  elab = K * FragmentA / ResidualA;
+  sig = 0.;
+ 
+  if (elab <= ec) { //start for E<Ec
+    if (elab > ecut2)  sig = (p*elab*elab+a*elab+b) * signor;
+  }           //end for E<Ec
+  else {           //start for E>Ec
+    sig = (landa*elab+mu+nu/elab) * signor;
+    geom = 0.;
+    if (xnulam < flow || elab < etest) return sig;
+    geom = std::sqrt(theA*K);
+    geom = 1.23*ResidualAthrd + ra + 4.573/geom;
+    geom = 31.416 * geom * geom;
+    sig = std::max(geom,sig);
+  }           //end for E>Ec
+  return sig;
 
 }
 
 //   ************************** end of cross sections ******************************* 
-
-
-
-
Index: trunk/source/processes/hadronic/models/pre_equilibrium/exciton_model/src/G4VPreCompoundFragment.cc
===================================================================
--- trunk/source/processes/hadronic/models/pre_equilibrium/exciton_model/src/G4VPreCompoundFragment.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/pre_equilibrium/exciton_model/src/G4VPreCompoundFragment.cc	(revision 1055)
@@ -24,7 +24,9 @@
 // ********************************************************************
 //
+// $Id: G4VPreCompoundFragment.cc,v 1.12 2009/02/10 16:01:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
-//J. M. Quesada (August 2008).  
-//Based  on previous work by V. Lara
+// J. M. Quesada (August 2008).  
+// Based  on previous work by V. Lara
 //
  
Index: trunk/source/processes/hadronic/models/qmd/GNUmakefile
===================================================================
--- trunk/source/processes/hadronic/models/qmd/GNUmakefile	(revision 1007)
+++ trunk/source/processes/hadronic/models/qmd/GNUmakefile	(revision 1055)
@@ -1,3 +1,3 @@
-# $Id: GNUmakefile,v 1.1 2007/11/17 16:27:35 dennis Exp $
+# $Id: GNUmakefile,v 1.2 2008/11/22 06:30:46 tkoi Exp $
 # -----------------------------------------------------------
 # GNUmakefile for hadronic library.  Gabriele Cosmo, 18/9/96.
@@ -27,5 +27,13 @@
 	    -I$(G4BASE)/processes/hadronic/models/management/include \
 	    -I$(G4BASE)/processes/hadronic/models/util/include \
+	    -I$(G4BASE)/processes/hadronic/models/theo_high_energy/include \
+	    -I$(G4BASE)/processes/hadronic/models/binary_cascade/include \
 	    -I$(G4BASE)/processes/hadronic/models/im_r_matrix/include \
+	    -I$(G4BASE)/processes/hadronic/models/chiral_inv_phase_space/interface/include \
+	    -I$(G4BASE)/processes/hadronic/models/chiral_inv_phase_space/body/include \
+	    -I$(G4BASE)/processes/hadronic/models/parton_string/qgsm/include \
+	    -I$(G4BASE)/processes/hadronic/models/parton_string/diffraction/include \
+	    -I$(G4BASE)/processes/hadronic/models/parton_string/hadronization/include \
+	    -I$(G4BASE)/processes/hadronic/models/parton_string/management/include \
             -I$(G4BASE)/processes/hadronic/models/de_excitation/util/include \
             -I$(G4BASE)/processes/hadronic/models/de_excitation/evaporation/include \
Index: trunk/source/processes/hadronic/models/qmd/History
===================================================================
--- trunk/source/processes/hadronic/models/qmd/History	(revision 1007)
+++ trunk/source/processes/hadronic/models/qmd/History	(revision 1055)
@@ -13,4 +13,17 @@
      * Please list in reverse chronological order (last date on top)
      ---------------------------------------------------------------
+
+31-March-2009 Tatsumi Koi (hadr-qmd-V09-02-01)
+- Fix bug in gamma(mass zero) partiticpants
+	src/G4QMDCollision.cc  
+- Chnage meber object to pointer
+	include/G4QMDReaction.hh  
+	src/G4QMDReaction.cc  
+
+28-February-2009 Tatsumi Koi (hadr-qmd-V09-02-00)
+- Fix bug in Absorption 
+	src/G4QMDCollision.cc  
+- Add Be8 -> Alpha Alpha including opening angle by Q value  
+	src/G4QMDReaction.cc  
 
 20-November-2008 Tatsumi Koi (hadr-qmd-V09-01-08)
Index: trunk/source/processes/hadronic/models/qmd/include/G4QMDReaction.hh
===================================================================
--- trunk/source/processes/hadronic/models/qmd/include/G4QMDReaction.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/qmd/include/G4QMDReaction.hh	(revision 1055)
@@ -28,5 +28,5 @@
 //
 //
-//      File name:    G4QMDReaction.hh 
+//      File name: G4QMDReaction.hh 
 //
 //      Author: Koi, Tatsumi (tkoi@slac.stanford.edu)       
@@ -37,4 +37,5 @@
 // 081107 Add UnUseGEM (then use the default channel of G4Evaporation)
 //            UseFrag (chage criterion of a inelastic reaction)
+// 090331 Change member shenXS and genspaXS object to pointer 
 //
 
@@ -70,7 +71,10 @@
       void UseFRAG(){ frag = true; };
 
+      void EnableFermiG(){ heg = true; setHighEnergyModel(); };
+
    private:
 
       void setEvaporationCh();
+      void setHighEnergyModel();
 
       G4QMDMeanField* meanField;
@@ -107,9 +111,11 @@
       G4double coulomb_collision_pz_targ;
 
-      G4IonsShenCrossSection shenXS;
-      G4IonsShenCrossSection genspaXS;
+//090331
+      G4IonsShenCrossSection* shenXS;
+      G4GeneralSpaceNNCrossSection* genspaXS;
 
       G4bool gem;
       G4bool frag;
+      G4bool heg;
 
 };
Index: trunk/source/processes/hadronic/models/qmd/src/G4QMDCollision.cc
===================================================================
--- trunk/source/processes/hadronic/models/qmd/src/G4QMDCollision.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/qmd/src/G4QMDCollision.cc	(revision 1055)
@@ -28,7 +28,8 @@
 //        Add several required updating of Mean Filed 
 //        Modified handling of absorption case by T. Koi
+// 090126 Fix in absorption case by T. Koi  
+// 090331 Fix for gamma participant by T. Koi 
 //
 #include "G4QMDCollision.hh"
-#include "G4ParticleDefinition.hh"
 #include "G4Scatterer.hh"
 #include "Randomize.hh"
@@ -260,4 +261,6 @@
       G4double rmi =  theSystem->GetParticipant( i )->GetMass();
       G4ParticleDefinition* pdi =  theSystem->GetParticipant( i )->GetDefinition();
+//090331 gamma 
+      if ( pdi->GetPDGMass() == 0.0 ) continue;
 
       //std::cout << " p4i00 " << p4i << std::endl;
@@ -295,4 +298,6 @@
          G4double rmj =  theSystem->GetParticipant( j )->GetMass();
          G4ParticleDefinition* pdj =  theSystem->GetParticipant( j )->GetDefinition();
+//090331 gamma 
+         if ( pdj->GetPDGMass() == 0.0 ) continue;
 
          G4double rr2 = theMeanField->GetRR2( i , j );
@@ -332,5 +337,5 @@
          G4double pidr = p4i.vect()*dr;
          G4double pjdr = p4j.vect()*dr;
-  
+
          G4double aij = 1.0 - ( rmi*rmj /pij ) * ( rmi*rmj /pij ); 
          G4double bij = pidr / rmi - pjdr*rmi/pij;
@@ -660,5 +665,7 @@
       else 
       {
-         if ( theMeanField->IsPauliBlocked ( i ) == false ) 
+         //if ( theMeanField->IsPauliBlocked ( i ) == false ) 
+         //090126                            i-1 cause jth is erased
+         if ( theMeanField->IsPauliBlocked ( i-1 ) == false ) 
          { 
             //G4cout << "Absorption Happen " << theSystem->GetTotalNumberOfParticipant() << G4endl;
